mui.init({
	gestureConfig:{
		release: true,
		longtap:true,
		hold:true
	}
});

var wv;
var unit;
var publicValue = [];
plusReady();
function plusReady() {
	var wv = JSON.parse(localStorage.getItem('extraDetail'));
	var code = wv.code;
	var country = wv.country;
	var beforeValue = wv.beforeValue;
	var indexValue = wv.indexValue;
	var dateContent = wv.dateContent;
	$('#title').html(dateContent);
	
	calendarInit(country,beforeValue,indexValue);
	var obj = {
		"sk":"0e3b2fbc60ef4058a8c9c5321eaad209",
		"ak":"a28e39c98ba744e2a0ff4b1c93e35337",
		"requestMethod":"GET",
		"requestURL" : '/api/v1/economic_calendar/history_affair_report',
		"params" : 'code='+code,//请求参数
		"successfn":caleHistorySuccess,
		"errfn":errfn
	}
	postAjax(obj);
	pageScroll();
}

function calendarInit(country,beforeValue,indexValue){
	var str='';
	str+='<div class="flag">';
	//国旗处理
	var caijingBi=country;
	var ki=pinyin.getFullChars(caijingBi);
	str += '<svg class="icon" aria-hidden="true">';
    str += '    <use xlink:href="#mui-icon-'+ki+'"></use>';
    str += '</svg>';
	str+='	<span class="calendarDetailCoun">'+country+'</span>';
	str+='</div>';
	str+='<div class="indexValue">今值: '+indexValue+'</div>';
	str+='<div class="beforeValue">前值: '+beforeValue+'</div>';
	console.log('#calenInit-----:'+str);
	$('#calenInit').html(str);
}

function caleHistorySuccess(data) {	
	var timeArry = [];
	var str = '';
	console.log(data.LIST);
	if(!data){
		$('#calendarHis').css('display','none');
		return;
	}
	for(var i = 0; i < data.LIST.length; i++) {
		str += '<li class="oneLine dataList">';
		str += '	<span class="reportValue">' + data.LIST[i].report_date + '</span>';
		str += '	<span class="publishValue">' + data.LIST[i].index_value + '</span>';
		str += '	<span class="frontValue">' + data.LIST[i].before_value + '</span>';
		str += '	<span class="forecastValue">' + data.LIST[i].pred_value + '</span>';
		str += '</li>';
		var ki = data.LIST[i].report_date.replace(/-/g, '/');
		var pi = data.LIST[i].index_value;
		if(pi == '-'){
		}else{
			timeArry.push(ki);
			publicValue.push(pi);
		}
	}
	$('#calendarHis').append(str);
	choseUnit();
	chartDraw(timeArry,publicValue);
}
function errfn(){
	
}

//页面滚动
function pageScroll(){
	window.addEventListener('scroll',function(){
		var bodyScroll = document.body.scrollTop || document.documentElement.scrollTop;
		var topHeight = parseInt($('.scale').css('height')) + parseInt($('.title').css('height'))+parseInt($('.myCanvas').css('height'))+parseInt($('.dataTitle').css('height'));
		if(bodyScroll >= topHeight){
			$('.tableHead').css({'position':'fixed','width':'100%','z-index':99999,'top':'44px'});
			$('#calendarHis li').eq(1).css('margin-top','50px');
		};
		if(bodyScroll <= topHeight){
			$('.tableHead').css({'position':'static','width':'100%','z-index':99999,'top':'44px'});
			$('#calendarHis li').eq(1).css('margin-top','0');
		}
	},false);
}

function choseUnit(){
	var maxPi = eval('Math.max('+publicValue.toString()+')');
	console.log('数组最大值'+maxPi);
	
	var maxPiStr = maxPi.toString();
	if(maxPiStr.indexOf('.') > 0){
		var useData = maxPiStr.substring(0,maxPiStr.indexOf('.'));
	}else{
		var useData = maxPiStr;
	}
	var dataUnit = useData.length;
	console.log('数组最大值的单位'+dataUnit)
	if(dataUnit >=4 && dataUnit <=6){
		for(var i =0;i<publicValue.length;i++ ){
			publicValue[i] = publicValue[i]/1000;
		}
		 unit = '比例 1:1,000';
	}else if(dataUnit>=7 && dataUnit<=9){
		for(var i =0;i<publicValue.length;i++ ){
			publicValue[i] = publicValue[i]/1000000;
		}
		 unit = '比例 1:1,000,000';
	}else if(dataUnit>=10 && dataUnit <= 11){
		for(var i =0;i<publicValue.length;i++ ){
			publicValue[i] = publicValue[i]/1000000000;
		}
		 unit = '比例 1:1,000,000,000';
	}else{
		 unit = '比例 1:1';
	}
	$('#scale').html(unit);
	unit = '';
}

function chartDraw(timeArry,publicValue) {
	timeArry=timeArry.reverse();
	publicValue=publicValue.reverse();
	var myCharts = echarts.init(document.querySelector('#myCanvas'));
	var option = {
		tooltip : {
	        trigger: 'axis'
	    },
		grid: {
			left: '48px',
			right: '28px',
			top: '30px',
			bottom: '30px',
		},
		xAxis: {
			type: 'category', //三种类型：类目型，时间性，数值型
			boundaryGap: true, //空白策略
			axisTick: {
				onGap: false
			}, //坐标轴上的小标签 萧作彪是否显示为间隔，默认为TRUE；
			splitLine: {
				show: false
			}, //分割线 默认显示 
			data: timeArry,
			axisTick: {
				show: false
			},
			axisLine: {
				show: false,
				onZero: false
			},
			axisLabel: {
				//          		interval:0,
				textStyle: {
					color: "#000",
				}
			},
		},
		yAxis: {
			nameLocation:'end',
			nameTextStyle:{
				color:'#000'
			},
			splitNumber: 1,
			axisTick: {
				show: false
			},
			axisLine: {
				show:false,
				lineStyle: {
					color: "red"
				},
				//          		onZero:'false'
			},
			axisLabel: {
				textStyle: {
					color: "#000"
				}
			},
		},
		series: [{
			name: "公布值",
			type: "line",
			data: publicValue,
			symbol: 'circle',
			symbolOffset: [0, '20%'],
			symbolSize: 6,
			smooth: true,
			symbol:'none',
			itemStyle: {
				normal: {
					color: "dodgerblue",
					areaStyle: {
						color: "deepskyblue"
					}
				}
			},
			lineStyle: {
				normal: {
					color: '#fff'
				}
			}
		}]
	};
	myCharts.setOption(option);
}

showTip();
//显示提示框
function getMousePos(e){ 
			return { 
				x : e.detail.touches[0].clientX|| e.targetTouches[0].clientX + document.body.scrollLeft, 
				y : e.detail.touches[0].clientY || e.targetTouches[0].clientY + document.body.scrollTop 
			} 
		} 
function showTip(){
	var leftOrRight = 'left';
	$('ul').on('touchstart','.dataList',function(){
		$(this).addClass('liTouch').siblings().removeClass('liTouch')
	})
	mui('ul').on('longtap','.dataList',function(e){
		$(this).trigger('touchstart');
		var _x = e.detail.touches[0].clientX;
        if(_x > 160){
			leftOrRight = 'right'
		}else{
			leftOrRight = 'left'
		}
		var  str = '<div class="tipsReportValue">'+$(this).find('.reportValue').html()+'</div>'
			 str += '<div class="tipsPublicValue"><span>公布值</span>'+$(this).find('.publishValue').html()+'</div>'
			 str += '<div class="tipsFrontValue"><span>前值</span>'+$(this).find('.frontValue').html()+'</div>'
			 str += '<div class="tipsForcastValue"><span>预测值</span>'+$(this).find('.forecastValue').html()+'</div>'
		$('.tips').html(str);
		var thisTop = $(this).position().top-$(window).scrollTop()+44;
		if(thisTop > 182){
			var tipsTop = thisTop-parseInt($('.tips').css('height'))
			if(leftOrRight == 'left'){
				$('.tips').css({'display':'block','top':tipsTop,'right':60,'left':'initial'});
			}else{
				$('.tips').css({'display':'block','top':tipsTop,'right':'initial','left':60});
			}
		}else{
			var tipsTop = thisTop+parseInt($(this).css('height'));
			console.log(tipsTop)
			if(leftOrRight == 'left'){
				$('.tips').css({'display':'block','top':tipsTop,'left':'initial','right':60});
			}else{
				$('.tips').css({'display':'block','top':tipsTop,'right':'initial','left':60});
			}
		}
	});
	$('ul').on('release','.dataList',function(){
		$('.tips').css('display','none');
		$(this).removeClass('liTouch')
	})
}
